Skip to main content
`Ctrl`+`K`

# numpy.bmat

numpy.bmat(obj, ldict=None, gdict=None)

  Build a matrix object from a string, nested sequence, or array.

  Parameters:
    obj str or array_like

      Input data. If a string, variables in the current scope may be referenced by name.

    ldict dict, optional

      A dictionary that replaces local operands in current frame. Ignored if obj is not a string or gdict is None.

    gdict dict, optional

      A dictionary that replaces global operands in current frame. Ignored if obj is not a string.

  Returns:
    out matrix

      Returns a matrix object, which is a specialized 2-D array.

  See also

  `block`

    A generalization of this function for N-d arrays, that returns normal ndarrays.

  Examples

      >>> import numpy as np
      >>> A = np.asmatrix('1 1; 1 1')
      >>> B = np.asmatrix('2 2; 2 2')
      >>> C = np.asmatrix('3 4; 5 6')
      >>> D = np.asmatrix('7 8; 9 0')

  All the following expressions construct the same block matrix:

      >>> np.bmat([[A, B], [C, D]])
      matrix([[1, 1, 2, 2],
              [1, 1, 2, 2],
              [3, 4, 7, 8],
              [5, 6, 9, 0]])
      >>> np.bmat(np.r_[np.c_[A, B], np.c_[C, D]])
      matrix([[1, 1, 2, 2],
              [1, 1, 2, 2],
              [3, 4, 7, 8],
              [5, 6, 9, 0]])
      >>> np.bmat('A,B; C,D')
      matrix([[1, 1, 2, 2],
              [1, 1, 2, 2],
              [3, 4, 7, 8],
              [5, 6, 9, 0]])